diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/constant-velocity-mobility-model.cc ns-3.43/src/mobility/model/constant-velocity-mobility-model.cc
--- ns-3.42/src/mobility/model/constant-velocity-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/constant-velocity-mobility-model.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006, 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/constant-velocity-mobility-model.h ns-3.43/src/mobility/model/constant-velocity-mobility-model.h
--- ns-3.42/src/mobility/model/constant-velocity-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/constant-velocity-mobility-model.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006, 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/gauss-markov-mobility-model.cc ns-3.43/src/mobility/model/gauss-markov-mobility-model.cc
--- ns-3.42/src/mobility/model/gauss-markov-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/gauss-markov-mobility-model.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 Dan Broyles
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Dan Broyles <dbroyl01@ku.edu>
  */
@@ -103,6 +92,11 @@
     m_helper.Unpause();
 }
 
+GaussMarkovMobilityModel::~GaussMarkovMobilityModel()
+{
+    m_event.Cancel();
+}
+
 void
 GaussMarkovMobilityModel::Start()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/gauss-markov-mobility-model.h ns-3.43/src/mobility/model/gauss-markov-mobility-model.h
--- ns-3.42/src/mobility/model/gauss-markov-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/gauss-markov-mobility-model.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 Dan Broyles
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Dan Broyles <dbroyl01@ku.edu>
  * Thanks to Kevin Peters, faculty advisor James P.G. Sterbenz, and the ResiliNets
@@ -87,6 +76,7 @@
      */
     static TypeId GetTypeId();
     GaussMarkovMobilityModel();
+    ~GaussMarkovMobilityModel() override;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.cc ns-3.43/src/mobility/model/geocentric-constant-position-mobility-model.cc
--- ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/geocentric-constant-position-mobility-model.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mattia Sandri <mattia.sandri@unipd.it>
  */
@@ -220,7 +209,7 @@
     x = std::max(x, -1.0);
 
     // asin returns radians, we convert to degrees
-    double elevAngle = abs((180.0 * M_1_PI) * asin(x));
+    double elevAngle = std::abs((180.0 * M_1_PI) * asin(x));
 
     return elevAngle;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.h ns-3.43/src/mobility/model/geocentric-constant-position-mobility-model.h
--- ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/geocentric-constant-position-mobility-model.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mattia Sandri <mattia.sandri@unipd.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/geographic-positions.cc ns-3.43/src/mobility/model/geographic-positions.cc
--- ns-3.42/src/mobility/model/geographic-positions.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/geographic-positions.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2014 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Benjamin Cizdziel <ben.cizdziel@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/geographic-positions.h ns-3.43/src/mobility/model/geographic-positions.h
--- ns-3.42/src/mobility/model/geographic-positions.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/geographic-positions.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2014 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Benjamin Cizdziel <ben.cizdziel@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/hierarchical-mobility-model.cc ns-3.43/src/mobility/model/hierarchical-mobility-model.cc
--- ns-3.42/src/mobility/model/hierarchical-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/hierarchical-mobility-model.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/hierarchical-mobility-model.h ns-3.43/src/mobility/model/hierarchical-mobility-model.h
--- ns-3.42/src/mobility/model/hierarchical-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/hierarchical-mobility-model.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/mobility.h ns-3.43/src/mobility/model/mobility.h
--- ns-3.42/src/mobility/model/mobility.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/mobility.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/mobility-model.cc ns-3.43/src/mobility/model/mobility-model.cc
--- ns-3.42/src/mobility/model/mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/mobility-model.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/mobility-model.h ns-3.43/src/mobility/model/mobility-model.h
--- ns-3.42/src/mobility/model/mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/mobility-model.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/position-allocator.cc ns-3.43/src/mobility/model/position-allocator.cc
--- ns-3.42/src/mobility/model/position-allocator.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/position-allocator.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/position-allocator.h ns-3.43/src/mobility/model/position-allocator.h
--- ns-3.42/src/mobility/model/position-allocator.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/position-allocator.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/random-direction-2d-mobility-model.cc ns-3.43/src/mobility/model/random-direction-2d-mobility-model.cc
--- ns-3.42/src/mobility/model/random-direction-2d-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/random-direction-2d-mobility-model.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -64,6 +53,11 @@
     m_direction = CreateObject<UniformRandomVariable>();
 }
 
+RandomDirection2dMobilityModel::~RandomDirection2dMobilityModel()
+{
+    m_event.Cancel();
+}
+
 void
 RandomDirection2dMobilityModel::DoDispose()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/random-direction-2d-mobility-model.h ns-3.43/src/mobility/model/random-direction-2d-mobility-model.h
--- ns-3.42/src/mobility/model/random-direction-2d-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/random-direction-2d-mobility-model.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -51,6 +40,7 @@
      */
     static TypeId GetTypeId();
     RandomDirection2dMobilityModel();
+    ~RandomDirection2dMobilityModel() override;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/random-walk-2d-mobility-model.cc ns-3.43/src/mobility/model/random-walk-2d-mobility-model.cc
--- ns-3.42/src/mobility/model/random-walk-2d-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/random-walk-2d-mobility-model.cc	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -80,16 +69,24 @@
     return tid;
 }
 
+RandomWalk2dMobilityModel::~RandomWalk2dMobilityModel()
+{
+    m_event.Cancel();
+}
+
 void
 RandomWalk2dMobilityModel::DoInitialize()
 {
-    DoInitializePrivate();
+    NS_LOG_FUNCTION(this);
+    DrawRandomVelocityAndDistance();
     MobilityModel::DoInitialize();
 }
 
+// Set new velocity and distance to travel, and call DoWalk() to initiate movement
 void
-RandomWalk2dMobilityModel::DoInitializePrivate()
+RandomWalk2dMobilityModel::DrawRandomVelocityAndDistance()
 {
+    NS_LOG_FUNCTION(this);
     m_helper.Update();
     Vector position = m_helper.GetCurrentPosition();
 
@@ -130,6 +127,7 @@
             break;
         }
     }
+    NS_LOG_INFO("Setting new velocity to " << velocity);
     m_helper.SetVelocity(velocity);
     m_helper.Unpause();
 
@@ -142,12 +140,15 @@
     {
         delayLeft = Seconds(m_modeDistance / speed);
     }
+    NS_LOG_INFO("Setting delayLeft for DoWalk() to " << delayLeft.As(Time::S));
     DoWalk(delayLeft);
 }
 
+// Notify course change and schedule event for either a wall rebound or a new velocity
 void
 RandomWalk2dMobilityModel::DoWalk(Time delayLeft)
 {
+    NS_LOG_FUNCTION(this << delayLeft.As(Time::S));
     Vector position = m_helper.GetCurrentPosition();
     Vector velocity = m_helper.GetVelocity();
     Vector nextPosition = position;
@@ -156,8 +157,10 @@
     m_event.Cancel();
     if (m_bounds.IsInside(nextPosition))
     {
-        m_event =
-            Simulator::Schedule(delayLeft, &RandomWalk2dMobilityModel::DoInitializePrivate, this);
+        NS_LOG_INFO("Scheduling new velocity in " << delayLeft.As(Time::S));
+        m_event = Simulator::Schedule(delayLeft,
+                                      &RandomWalk2dMobilityModel::DrawRandomVelocityAndDistance,
+                                      this);
     }
     else
     {
@@ -179,6 +182,7 @@
                          "(the node is stationary).");
         }
         Time delay = Seconds(delaySeconds);
+        NS_LOG_INFO("Scheduling a rebound event in " << (delayLeft - delay).As(Time::S));
         m_event = Simulator::Schedule(delay,
                                       &RandomWalk2dMobilityModel::Rebound,
                                       this,
@@ -187,9 +191,11 @@
     NotifyCourseChange();
 }
 
+// Set a velocity from the previous velocity, and start motion with remaining time
 void
 RandomWalk2dMobilityModel::Rebound(Time delayLeft)
 {
+    NS_LOG_FUNCTION(this << delayLeft.As(Time::S));
     m_helper.UpdateWithBounds(m_bounds);
     Vector position = m_helper.GetCurrentPosition();
     Vector velocity = m_helper.GetVelocity();
@@ -213,6 +219,7 @@
     }
     m_helper.SetVelocity(velocity);
     m_helper.Unpause();
+    NS_LOG_INFO("Rebounding with new velocity " << velocity);
     DoWalk(delayLeft);
 }
 
@@ -220,6 +227,7 @@
 RandomWalk2dMobilityModel::DoDispose()
 {
     // chain up
+    NS_LOG_FUNCTION(this);
     MobilityModel::DoDispose();
 }
 
@@ -233,10 +241,12 @@
 void
 RandomWalk2dMobilityModel::DoSetPosition(const Vector& position)
 {
+    NS_LOG_FUNCTION(this << position);
     NS_ASSERT(m_bounds.IsInside(position));
     m_helper.SetPosition(position);
     m_event.Cancel();
-    m_event = Simulator::ScheduleNow(&RandomWalk2dMobilityModel::DoInitializePrivate, this);
+    m_event =
+        Simulator::ScheduleNow(&RandomWalk2dMobilityModel::DrawRandomVelocityAndDistance, this);
 }
 
 Vector
@@ -248,6 +258,7 @@
 int64_t
 RandomWalk2dMobilityModel::DoAssignStreams(int64_t stream)
 {
+    NS_LOG_FUNCTION(this << stream);
     m_speed->SetStream(stream);
     m_direction->SetStream(stream + 1);
     return 2;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/random-walk-2d-mobility-model.h ns-3.43/src/mobility/model/random-walk-2d-mobility-model.h
--- ns-3.42/src/mobility/model/random-walk-2d-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/random-walk-2d-mobility-model.h	2024-10-09 16:41:10.056656600 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -57,6 +46,8 @@
      */
     static TypeId GetTypeId();
 
+    ~RandomWalk2dMobilityModel() override;
+
     /** An enum representing the different working modes of this module. */
     enum Mode
     {
@@ -77,9 +68,9 @@
      */
     void DoWalk(Time timeLeft);
     /**
-     * Perform initialization of the object before MobilityModel::DoInitialize ()
+     * Draw a new random velocity and distance to travel, and call DoWalk()
      */
-    void DoInitializePrivate();
+    void DrawRandomVelocityAndDistance();
     void DoDispose() override;
     void DoInitialize() override;
     Vector DoGetPosition() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/random-waypoint-mobility-model.cc ns-3.43/src/mobility/model/random-waypoint-mobility-model.cc
--- ns-3.42/src/mobility/model/random-waypoint-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/random-waypoint-mobility-model.cc	2024-10-09 16:41:10.060656500 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -59,6 +48,11 @@
     return tid;
 }
 
+RandomWaypointMobilityModel::~RandomWaypointMobilityModel()
+{
+    m_event.Cancel();
+}
+
 void
 RandomWaypointMobilityModel::BeginWalk()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/random-waypoint-mobility-model.h ns-3.43/src/mobility/model/random-waypoint-mobility-model.h
--- ns-3.42/src/mobility/model/random-waypoint-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/random-waypoint-mobility-model.h	2024-10-09 16:41:10.060656500 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -59,6 +48,8 @@
      */
     static TypeId GetTypeId();
 
+    ~RandomWaypointMobilityModel() override;
+
   protected:
     void DoInitialize() override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/mobility/model/rectangle.cc ns-3.43/src/mobility/model/rectangle.cc
--- ns-3.42/src/mobility/model/rectangle.cc	2024-05-29 15:29:47.136073600 -0700
+++ ns-3.43/src/mobility/model/rectangle.cc	2024-10-09 16:41:10.060656500 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
